<template>
  <box-content>
    <div class="search">
      <el-form :inline="true" size="small" class="base-search-form">
        <el-form-item label="CRO Name:">
          <el-input :maxLength="$inputMax" v-model="searchData.CROName" style="width:100px;" />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" @click="handleSearch">Search</el-button>
          <el-button type="primary" icon="el-icon-refresh-left" @click="handleReset">Reset</el-button>
        </el-form-item>
      </el-form>
      <span style="margin-left:auto;">
        <el-button
          size="small"
          type="primary"
          style="margin-left:auto;"
          icon="el-icon-plus"
          @click="handleAddCro"
        >New</el-button>
      </span>
    </div>
    <el-table
      v-loading="loading"
      v-adaptive="{bottomOffset:60}"
      :data="list"
      stripe
      height="100"
      @sort-change="handleSortByColumn"
    >
      <el-table-column type="index" width="40" />
      <el-table-column
        prop="CROCode"
        label="CRO Code"
        min-width="150"
        show-overflow-tooltip
        sortable="custom"
      />
      <el-table-column
        prop="CROName"
        label="CRO Name"
        min-width="150"
        show-overflow-tooltip
        sortable="custom"
      />
      <el-table-column
        prop="CRONameCN"
        label="CRO NameCN"
        min-width="150"
        show-overflow-tooltip
        sortable="custom"
      />
      <el-table-column label="Action" min-width="200">
        <template slot-scope="scope">
          <el-button
            circle
            icon="el-icon-edit-outline"
            title="编辑"
            @click="handleEdit(scope.row)"
          />
          <el-button
            circle
            icon="el-icon-delete"
            title="删除"
            @click="handleDelete(scope.row)"
          />
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination class="page" :total="total" :page.sync="searchData.PageIndex" :limit.sync="searchData.PageSize" @pagination="getList" />

    <el-dialog
      v-if="editVisible"
      :visible.sync="editVisible"
      :close-on-click-modal="false"
      :title="title"
      width="600px"
      custom-class="base-dialog-wrapper"
    >
      <CroForm v-if="editVisible" :data="rowData" @close="close" @getList="getList" />
    </el-dialog>
  </box-content>
</template>
<script>
import { getCROPageList, deleteCROCompany } from '@/api/dictionary'
import BoxContent from '@/components/BoxContent'
import Pagination from '@/components/Pagination'
import CroForm from './CroForm'
const searchDataDefault = () => {
  return {
    CROName: '',
    PageIndex: 1,
    PageSize: 20,
    Asc: true,
    SortField: ''
  }
}
export default {
  name: 'Cros',
  components: { BoxContent, Pagination, CroForm },
  data() {
    return {
      searchData: searchDataDefault(),
      list: [],
      total: 0,
      loading: false,
      rowData: {},
      editVisible: false,
      title: ''
    }
  },
  mounted() {
    this.getList()
  },
  methods: {
    // 获取CRO列表信息
    getList() {
      this.loading = true
      getCROPageList(this.searchData).then(res => {
        this.loading = false
        this.list = res.Result.CurrentPageData
        this.total = res.Result.TotalCount
      }).catch(() => {
        this.loading = false
      })
    },
    // 新增CRO
    handleAddCro() {
      this.rowData = {}
      this.title = 'Add'
      this.editVisible = true
    },
    // 编辑CRO
    handleEdit(row) {
      this.rowData = row
      this.title = 'Edit'
      this.editVisible = true
    },
    // 删除CRO
    handleDelete(row) {
      this.$confirm('Sure to delete?', {
        type: 'warning',
        distinguishCancelAndClose: true,
        confirmButtonText: 'Ok',
        cancelButtonText: 'Cancel'
      })
        .then(() => {
          this.loading = true
          deleteCROCompany(row.Id)
            .then(res => {
              this.loading = false
              if (res.IsSuccess) {
                this.list.splice(this.list.findIndex(item => item.Id === row.Id), 1)
                this.$message.success(this.$t('common:message:deletedSuccessfully'))
              }
            }).catch(() => {
              this.loading = false
            })
        })
    },
    // 重置列表
    handleReset() {
      this.searchData = searchDataDefault()
      this.getList()
    },
    // 查询
    handleSearch() {
      this.searchData.PageIndex = 1
      this.getList()
    },
    // 指定排序字段，对列表进行排序
    handleSortByColumn(column) {
      if (column.order === 'ascending') {
        this.searchData.Asc = true
      } else {
        this.searchData.Asc = false
      }
      this.searchData.SortField = column.prop
      this.searchData.PageIndex = 1
      this.getList()
    },
    // 关闭模态框
    close() {
      this.editVisible = false
    }
  }
}
</script>
<style lang="scss" scoped>
.cros{
  height: 100%;
}
</style>
